(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports) :
    typeof define === 'function' && define.amd ? define(['exports'], factory) :
    (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory(global.synchsafe = {}));
})(this, (function (exports) { 'use strict';

    /**
     * This functions turns a synchronisation-saved integer into regular one.
     */
    var decode = function decode(synchsafed) {
      var mask = 0x7f000000;
      var unsynchsafed = 0;
      while (mask !== 0) {
        unsynchsafed >>= 1; // tslint:disable-line no-bitwise
        unsynchsafed |= synchsafed & mask; // tslint:disable-line no-bitwise
        mask >>= 8; // tslint:disable-line no-bitwise
      }
      return unsynchsafed;
    };
    /**
     * This functions turns a regular integer into synchronisation-saved one.
     */
    var encode = function encode(unsynchsafed) {
      var mask = 0x7f;
      var synchsafed;
      var unsynchsafedRest = unsynchsafed;
      // tslint:disable-next-line:no-bitwise
      while ((mask ^ 0x7fffffff) !== 0) {
        synchsafed = unsynchsafedRest & ~mask; // tslint:disable-line no-bitwise
        synchsafed <<= 1; // tslint:disable-line no-bitwise
        synchsafed |= unsynchsafedRest & mask; // tslint:disable-line no-bitwise
        mask = (mask + 1 << 8) - 1; // tslint:disable-line no-bitwise
        unsynchsafedRest = synchsafed;
      }
      return synchsafed;
    };

    exports.decode = decode;
    exports.encode = encode;

}));
